﻿/*
 * Created by SharpDevelop.
 * User: kilkenny
 * Date: 30.07.2015
 * Time: 18:27
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
using System;
using System.Globalization;
using System.Xml;
using System.Collections.Generic;
using System.Drawing;
using System.Windows.Forms;
using System.IO;


namespace dsn_viewer
{
	public partial class MainForm : Form
	{			
		public MainForm()
		{
			InitializeComponent();
		}
		
		void BtnFilenameClick(object sender, EventArgs e)
		{
			if (openFileDialog.ShowDialog() != DialogResult.OK)
				return;
			this.Text = "DSN viewer - " + openFileDialog.FileName;
			var txtDsn = File.ReadAllText(openFileDialog.FileName);
			if (txtDsn.Length < 100)
				return;
			
			var level = -1;
			var b = "";
			var Dsn = new List<string>();
			for (var i = 0; i < txtDsn.Length; i++) {
				switch (txtDsn[i]) {
					case '(':
					case ')':
						b = b.Trim();
						if (b.Length > 0)
							Dsn.Add(level + b);
						b = "";
						if (txtDsn[i] == '(')
							level++;
						else
							level--;
						break;
					case '\r':
					case '\n':
						continue;
					default:
						b += txtDsn[i];	
						continue;						
				}
			}
			dsnTree.Nodes.Clear();
			var parents = new Dictionary<int, TreeNode>();
			foreach (string astr in Dsn) {
				level = (int)Char.GetNumericValue(astr[0]);
				if (level == 0)
					parents[level] = dsnTree.Nodes.Add(astr.Remove(0, 1));
				else
					parents[level] = parents[level - 1].Nodes.Add(astr.Remove(0, 1));
			}
			dsnTree.Nodes[0].Expand();
		}

		void AboutToolStripMenuItemClick(object sender, EventArgs e)
		{
			p_about.Left = (int)((this.Width - p_about.Width)/2);
			p_about.Top = (int)((this.Height - p_about.Height)/2);
			p_about.Visible = true;
		}
		void ExitToolStripMenuItemClick(object sender, EventArgs e)
		{
			Application.Exit();
		}
		void DsnTreeClick(object sender, EventArgs e)
		{
			p_about.Visible = false;
		}
	}
}
